// Generated by gencpp from file ld_msgs/ld_roadedgepara.msg
// DO NOT EDIT!


#ifndef LD_MSGS_MESSAGE_LD_ROADEDGEPARA_H
#define LD_MSGS_MESSAGE_LD_ROADEDGEPARA_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>

#include <std_msgs/Header.h>

namespace ld_msgs
{
template <class ContainerAllocator>
struct ld_roadedgepara_
{
  typedef ld_roadedgepara_<ContainerAllocator> Type;

  ld_roadedgepara_()
    : header()
    , left_roadedge(false)
    , right_roadedge(false)
    , left_line(false)
    , right_line(false)
    , left_curve(false)
    , right_curve(false)
    , left_roadedgecoordination(0.0)
    , right_roadedgecoordination(0.0)
    , left_roadedgevariance(0.0)
    , right_roadedgevariance(0.0)
    , x_min(0.0)
    , x_max(0.0)
    , y_min(0.0)
    , y_max(0.0)
    , left_flag_a(0.0)
    , left_flag_b(0.0)
    , left_flag_c(0.0)
    , left_flag_d(0.0)
    , right_flag_a(0.0)
    , right_flag_b(0.0)
    , right_flag_c(0.0)
    , right_flag_d(0.0)
    , flags_number(0)  {
    }
  ld_roadedgepara_(const ContainerAllocator& _alloc)
    : header(_alloc)
    , left_roadedge(false)
    , right_roadedge(false)
    , left_line(false)
    , right_line(false)
    , left_curve(false)
    , right_curve(false)
    , left_roadedgecoordination(0.0)
    , right_roadedgecoordination(0.0)
    , left_roadedgevariance(0.0)
    , right_roadedgevariance(0.0)
    , x_min(0.0)
    , x_max(0.0)
    , y_min(0.0)
    , y_max(0.0)
    , left_flag_a(0.0)
    , left_flag_b(0.0)
    , left_flag_c(0.0)
    , left_flag_d(0.0)
    , right_flag_a(0.0)
    , right_flag_b(0.0)
    , right_flag_c(0.0)
    , right_flag_d(0.0)
    , flags_number(0)  {
  (void)_alloc;
    }



   typedef  ::std_msgs::Header_<ContainerAllocator>  _header_type;
  _header_type header;

   typedef uint8_t _left_roadedge_type;
  _left_roadedge_type left_roadedge;

   typedef uint8_t _right_roadedge_type;
  _right_roadedge_type right_roadedge;

   typedef uint8_t _left_line_type;
  _left_line_type left_line;

   typedef uint8_t _right_line_type;
  _right_line_type right_line;

   typedef uint8_t _left_curve_type;
  _left_curve_type left_curve;

   typedef uint8_t _right_curve_type;
  _right_curve_type right_curve;

   typedef float _left_roadedgecoordination_type;
  _left_roadedgecoordination_type left_roadedgecoordination;

   typedef float _right_roadedgecoordination_type;
  _right_roadedgecoordination_type right_roadedgecoordination;

   typedef float _left_roadedgevariance_type;
  _left_roadedgevariance_type left_roadedgevariance;

   typedef float _right_roadedgevariance_type;
  _right_roadedgevariance_type right_roadedgevariance;

   typedef float _x_min_type;
  _x_min_type x_min;

   typedef float _x_max_type;
  _x_max_type x_max;

   typedef float _y_min_type;
  _y_min_type y_min;

   typedef float _y_max_type;
  _y_max_type y_max;

   typedef float _left_flag_a_type;
  _left_flag_a_type left_flag_a;

   typedef float _left_flag_b_type;
  _left_flag_b_type left_flag_b;

   typedef float _left_flag_c_type;
  _left_flag_c_type left_flag_c;

   typedef float _left_flag_d_type;
  _left_flag_d_type left_flag_d;

   typedef float _right_flag_a_type;
  _right_flag_a_type right_flag_a;

   typedef float _right_flag_b_type;
  _right_flag_b_type right_flag_b;

   typedef float _right_flag_c_type;
  _right_flag_c_type right_flag_c;

   typedef float _right_flag_d_type;
  _right_flag_d_type right_flag_d;

   typedef int32_t _flags_number_type;
  _flags_number_type flags_number;





  typedef boost::shared_ptr< ::ld_msgs::ld_roadedgepara_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::ld_msgs::ld_roadedgepara_<ContainerAllocator> const> ConstPtr;

}; // struct ld_roadedgepara_

typedef ::ld_msgs::ld_roadedgepara_<std::allocator<void> > ld_roadedgepara;

typedef boost::shared_ptr< ::ld_msgs::ld_roadedgepara > ld_roadedgeparaPtr;
typedef boost::shared_ptr< ::ld_msgs::ld_roadedgepara const> ld_roadedgeparaConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::ld_msgs::ld_roadedgepara_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::ld_msgs::ld_roadedgepara_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace ld_msgs

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': False, 'IsMessage': True, 'HasHeader': True}
// {'sensor_msgs': ['/opt/ros/kinetic/share/sensor_msgs/cmake/../msg'], 'std_msgs': ['/opt/ros/kinetic/share/std_msgs/cmake/../msg'], 'geometry_msgs': ['/opt/ros/kinetic/share/geometry_msgs/cmake/../msg'], 'ld_msgs': ['/home/lddev001/catkin_ws/src/ld_msgs/msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::ld_msgs::ld_roadedgepara_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::ld_msgs::ld_roadedgepara_<ContainerAllocator> const>
  : FalseType
  { };

template <class ContainerAllocator>
struct IsMessage< ::ld_msgs::ld_roadedgepara_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::ld_msgs::ld_roadedgepara_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::ld_msgs::ld_roadedgepara_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::ld_msgs::ld_roadedgepara_<ContainerAllocator> const>
  : TrueType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::ld_msgs::ld_roadedgepara_<ContainerAllocator> >
{
  static const char* value()
  {
    return "41318e71c0186ec8f8b73b8424ef73f5";
  }

  static const char* value(const ::ld_msgs::ld_roadedgepara_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0x41318e71c0186ec8ULL;
  static const uint64_t static_value2 = 0xf8b73b8424ef73f5ULL;
};

template<class ContainerAllocator>
struct DataType< ::ld_msgs::ld_roadedgepara_<ContainerAllocator> >
{
  static const char* value()
  {
    return "ld_msgs/ld_roadedgepara";
  }

  static const char* value(const ::ld_msgs::ld_roadedgepara_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::ld_msgs::ld_roadedgepara_<ContainerAllocator> >
{
  static const char* value()
  {
    return "Header header\n\
\n\
bool left_roadedge\n\
\n\
bool right_roadedge\n\
\n\
bool left_line\n\
\n\
bool right_line\n\
\n\
bool left_curve\n\
\n\
bool right_curve\n\
\n\
float32 left_roadedgecoordination\n\
\n\
float32 right_roadedgecoordination\n\
\n\
float32 left_roadedgevariance\n\
\n\
float32 right_roadedgevariance\n\
\n\
float32 x_min\n\
\n\
float32 x_max\n\
\n\
float32 y_min\n\
\n\
float32 y_max\n\
\n\
float32 left_flag_a\n\
\n\
float32 left_flag_b\n\
\n\
float32 left_flag_c\n\
\n\
float32 left_flag_d\n\
\n\
float32 right_flag_a\n\
\n\
float32 right_flag_b\n\
\n\
float32 right_flag_c\n\
\n\
float32 right_flag_d\n\
\n\
int32 flags_number\n\
\n\
================================================================================\n\
MSG: std_msgs/Header\n\
# Standard metadata for higher-level stamped data types.\n\
# This is generally used to communicate timestamped data \n\
# in a particular coordinate frame.\n\
# \n\
# sequence ID: consecutively increasing ID \n\
uint32 seq\n\
#Two-integer timestamp that is expressed as:\n\
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')\n\
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')\n\
# time-handling sugar is provided by the client library\n\
time stamp\n\
#Frame this data is associated with\n\
# 0: no frame\n\
# 1: global frame\n\
string frame_id\n\
";
  }

  static const char* value(const ::ld_msgs::ld_roadedgepara_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::ld_msgs::ld_roadedgepara_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.header);
      stream.next(m.left_roadedge);
      stream.next(m.right_roadedge);
      stream.next(m.left_line);
      stream.next(m.right_line);
      stream.next(m.left_curve);
      stream.next(m.right_curve);
      stream.next(m.left_roadedgecoordination);
      stream.next(m.right_roadedgecoordination);
      stream.next(m.left_roadedgevariance);
      stream.next(m.right_roadedgevariance);
      stream.next(m.x_min);
      stream.next(m.x_max);
      stream.next(m.y_min);
      stream.next(m.y_max);
      stream.next(m.left_flag_a);
      stream.next(m.left_flag_b);
      stream.next(m.left_flag_c);
      stream.next(m.left_flag_d);
      stream.next(m.right_flag_a);
      stream.next(m.right_flag_b);
      stream.next(m.right_flag_c);
      stream.next(m.right_flag_d);
      stream.next(m.flags_number);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER
  }; // struct ld_roadedgepara_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::ld_msgs::ld_roadedgepara_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::ld_msgs::ld_roadedgepara_<ContainerAllocator>& v)
  {
    s << indent << "header: ";
    s << std::endl;
    Printer< ::std_msgs::Header_<ContainerAllocator> >::stream(s, indent + "  ", v.header);
    s << indent << "left_roadedge: ";
    Printer<uint8_t>::stream(s, indent + "  ", v.left_roadedge);
    s << indent << "right_roadedge: ";
    Printer<uint8_t>::stream(s, indent + "  ", v.right_roadedge);
    s << indent << "left_line: ";
    Printer<uint8_t>::stream(s, indent + "  ", v.left_line);
    s << indent << "right_line: ";
    Printer<uint8_t>::stream(s, indent + "  ", v.right_line);
    s << indent << "left_curve: ";
    Printer<uint8_t>::stream(s, indent + "  ", v.left_curve);
    s << indent << "right_curve: ";
    Printer<uint8_t>::stream(s, indent + "  ", v.right_curve);
    s << indent << "left_roadedgecoordination: ";
    Printer<float>::stream(s, indent + "  ", v.left_roadedgecoordination);
    s << indent << "right_roadedgecoordination: ";
    Printer<float>::stream(s, indent + "  ", v.right_roadedgecoordination);
    s << indent << "left_roadedgevariance: ";
    Printer<float>::stream(s, indent + "  ", v.left_roadedgevariance);
    s << indent << "right_roadedgevariance: ";
    Printer<float>::stream(s, indent + "  ", v.right_roadedgevariance);
    s << indent << "x_min: ";
    Printer<float>::stream(s, indent + "  ", v.x_min);
    s << indent << "x_max: ";
    Printer<float>::stream(s, indent + "  ", v.x_max);
    s << indent << "y_min: ";
    Printer<float>::stream(s, indent + "  ", v.y_min);
    s << indent << "y_max: ";
    Printer<float>::stream(s, indent + "  ", v.y_max);
    s << indent << "left_flag_a: ";
    Printer<float>::stream(s, indent + "  ", v.left_flag_a);
    s << indent << "left_flag_b: ";
    Printer<float>::stream(s, indent + "  ", v.left_flag_b);
    s << indent << "left_flag_c: ";
    Printer<float>::stream(s, indent + "  ", v.left_flag_c);
    s << indent << "left_flag_d: ";
    Printer<float>::stream(s, indent + "  ", v.left_flag_d);
    s << indent << "right_flag_a: ";
    Printer<float>::stream(s, indent + "  ", v.right_flag_a);
    s << indent << "right_flag_b: ";
    Printer<float>::stream(s, indent + "  ", v.right_flag_b);
    s << indent << "right_flag_c: ";
    Printer<float>::stream(s, indent + "  ", v.right_flag_c);
    s << indent << "right_flag_d: ";
    Printer<float>::stream(s, indent + "  ", v.right_flag_d);
    s << indent << "flags_number: ";
    Printer<int32_t>::stream(s, indent + "  ", v.flags_number);
  }
};

} // namespace message_operations
} // namespace ros

#endif // LD_MSGS_MESSAGE_LD_ROADEDGEPARA_H
